# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTIBILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
# ======================================================================
__version__= '3.5'


from Globals import HTMLFile,MessageDialog
from ImageFile import ImageFile  
import SQLForms





#html-add-form
manage_addSQLFormsForm = HTMLFile('dtml/add_form', globals())




methods={
    #I need this to make visible ScriptsIDs from dtml
    'ReturnIDs': SQLForms.ReturnIDs,

    }



#action for html-add-form
def manage_addSQLForms(self, id='',title='',sq_table='',database='', REQUEST=None, submit=None):
    """Add a SQLForm Object """
    if id=='':
        return MessageDialog( title='Error', message='Please enter an id!', action = REQUEST['URL1']+'/add_form',)
    if database=='':
        return MessageDialog( title='Error', message='''
        Please select a database adaptor!<br>
        If no database adaptors available, please add some!
        ''', action = REQUEST['URL1']+'/add_form',)
    if sq_table=='':
        return MessageDialog( title='Error', message='Please enter a table name!', action = REQUEST['URL1']+'/add_form',)
    ob=SQLForms.SQLFormsDocument(id, title,database,sq_table)
    ob.title=title
    id=self._setObject(id, ob)
    if REQUEST is not None:
        try: u=self.DestinationURL()
        except: u=REQUEST['URL1']
        if submit=="Add": u="%s/%s" % (u,quote(id))
        REQUEST.RESPONSE.redirect(u+'/manage_main')
    return 'Nothing'




# Load images from disk and make them accessible
misc_={
       'up_img':         ImageFile('img/up.gif',globals()),
       'down_img':       ImageFile('img/down.gif',globals()),
       'icon':           ImageFile('img/forms.gif',globals()),
      }  






def initialize(context): 
    """Initialize the product."""
    
    try: 
        context.registerClass(
            SQLForms.SQLFormsDocument,
            #permission='Add SQL Forms', #automatically included; I don't need to specify it
            constructors = (                 
                manage_addSQLFormsForm,  #html file; html-form has action next constructor
                manage_addSQLForms),     #constructor caled from html-form (action)                                            
            )
        context.registerBaseClass(SQLForms.SQLFormsDocument)

    except:
        import sys, traceback, string
        type, val, tb = sys.exc_info()
        sys.stderr.write(string.join(traceback.format_exception(type, val, tb), ''))
        del type, val, tb

    context.registerHelp()
    context.registerHelpTitle('SQL Forms')

